LeetCode 1.两数之和【力扣——C/C++/Python三种编程语言题解】
LeetCode刷题篇,按照LeetCode专项突破的顺序进行,每道题通过C、C++、Python三种编程语言来解答。
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
🏆C语言版
使用两层循环求解
/**
* Note: The returned array must be malloced, assume caller calls free().
*/
int* twoSum(int* nums, int numsSize, int target, int* returnSize){
int i = 0, j = 0;
int* ret = (int *)malloc(2 * sizeof(int));
for(i = 0; i < numsSize; i++)
{
for(j = i + 1; j < numsSize; j++)
{
if((nums[i] + nums[j]) == target)
{
*ret = i;
*(ret + 1) = j;
}
}
}
*returnSize = 2;
return ret;
}
🏆C++版
使用哈希,unordered_map底层实现为散列,相对于有序的map来说效率更高一些,因为unordered_map是无序的。
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
unordered_map<int, int> m;
int i = 0;
do
{
unordered_map<int, int>::iterator it = m.find(target - nums[i]);
if(it != m.end())
{
return {it->second, i};
}
else
{
m.insert(pair<int, int>(nums[i], i));
i++;
}
}while(i < nums.size());
return {};
}
};
🏆Python版
使用字典,在python中,字典就是散列。
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
hashmap = {}
for key, val in enumerate(nums):
if target - val in hashmap:
return [key, hashmap[target - val]]
hashmap[val] = key